unit Unit1;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, ExtCtrls, Stdctrls,
	DoCombo97,
	DCombo97,
	SCombo97,
	FontCombo97,
	SoCombo97,
	LangSel97;

	type
	 TForm1 = class(TForm)

    Label1: TLabel;
    Panel1: TPanel;
		DComboBox97: TDComboBox97;
		Edit1: TEdit;
		Label2: TLabel;
		SComboBox97: TSComboBox97;
		Edit2: TEdit;
		Label3: TLabel;
		Button1: TButton;
		Button2: TButton;
		BmpCombo: TDoComboBox97;
		Label4: TLabel;
		SoComboBox97: TSoComboBox97;
		SoComboBox971: TSoComboBox97;
		FontCombo971: TFontCombo97;
		LanguageSelector971: TLanguageSelector97;
		Label5: TLabel;
		Button3: TButton;
		procedure DComboBox97Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SComboBox97Change(Sender: TObject);
    procedure SoComboBox97Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FontCombo971Change(Sender: TObject);
    procedure LanguageSelector971Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
	private
		procedure BuildColorList;
	end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{$R Bitmaps}

const
  ColorArray: array[0..16] of TColor =
  (
    clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clGray,
		clSilver, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clWhite,
		clNone
	);

procedure TForm1.BuildColorList;
var
	c: integer;
	s: String;
	bmp, bm : TBitmap;
	Rect : TRect;
begin
	bmp := TBitmap.Create;
	with SoComboBox97.Items do begin
		  clear;
		  for c := 0 to High(ColorArray) do
			if ColorToIdent(ColorArray[c], s) then
			  begin
			       with bmp,Canvas do
			       begin
				  width := 16;
				  height := 16;
             	  Rect := Bounds(1,1,bmp.width-2,bmp.height-2);
      		  Brush.Color := StringToColor(s);
				  Brush.Style := bsSolid;
				  FillRect(Rect);
				  Brush.Color := clBlack;
				  FrameRect(Rect);
			       end;
				bm:=TBitmap.Create;
				bm.Assign(bmp);
				AddObject(s,bm);
			  end;
		end;
	bmp.free;
end;

procedure TForm1.DComboBox97Change(Sender: TObject);
begin
		 Edit1.Text := DComboBox97.Text;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     SComboBox97.Items.Add(Edit2.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     SComboBox97.Clear;
end;

procedure TForm1.SComboBox97Change(Sender: TObject);
begin
		 Edit2.Text := SComboBox97.Text;
end;

procedure TForm1.SoComboBox97Change(Sender: TObject);
var
	 Result :TColor;
begin
		 Result := clBtnFace;
		 try
			 begin
			    if SoComboBox97.ItemIndex >= 0 then
			    if not IdentToColor(SoComboBox97.Items[SoComboBox97.ItemIndex], LongInt(result))
			      then Result := clBtnFace;
			 end;
		 finally
			 Panel1.Color := Result;
		 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
	 b0,b1,b2:TBitmap;
begin
		 BuildColorList;

		 b0 := TBitmap.Create;
		 b0.Handle := LoadBitmap(HInstance, 'B0');
		 b1 := TBitmap.Create;
		 b1.Handle := LoadBitmap(HInstance, 'B1');
		 b2 := TBitmap.Create;
		 b2.Handle := LoadBitmap(HInstance, 'B2');

		 SoComboBox971.Items.AddObject('Bitmap1', b1);
		 SoComboBox971.Items.AddObject('Bitmap2', b2);
		 SoComboBox971.Items.AddObject('Empty Bitmap', b0);
		 SoComboBox971.Items.AddObject('Empty Bitmap', b0);
		 SoComboBox971.Items.AddObject('Bitmap3', b1);
		 SoComboBox971.Items.Add(' Only Item');
		 SoComboBox971.Items.AddObject('Bitmap5', b2);
		 SoComboBox971.Items.AddObject('Empty Bitmap', b0);
		 SoComboBox971.Items.AddObject('Empty Bitmap', b0);
		 SoComboBox971.Items.AddObject('Bitmap6', b1);
		 SoComboBox971.Items.AddObject('Bitmap7', b2);

		 BmpCombo.Items.AddObject('Bitmap1', b1);
		 BmpCombo.Items.AddObject('Bitmap2', b2);
		 BmpCombo.Items.AddObject('Empty Bitmap', b0);
		 BmpCombo.Items.AddObject('Empty Bitmap', b0);
		 BmpCombo.Items.AddObject('Bitmap3', b1);
		 BmpCombo.Items.Add(' Only Item');
		 BmpCombo.Items.AddObject('Bitmap5', b2);
		 BmpCombo.Items.AddObject('Empty Bitmap', b0);
		 BmpCombo.Items.AddObject('Empty Bitmap', b0);
		 BmpCombo.Items.AddObject('Bitmap6', b1);
		 BmpCombo.Items.AddObject('Bitmap7', b2);

		 Label5.Caption := 'Language identifiers = ' + LanguageSelector971.LangIdAsString;
end;

procedure TForm1.FontCombo971Change(Sender: TObject);
begin
		 if not (FontCombo971.Text = ' Font Combo 97') then
		 Label4.Font.Name := FontCombo971.Text;
end;

procedure TForm1.LanguageSelector971Change(Sender: TObject);
begin
		 Label5.Caption := 'Language identifiers = ' + LanguageSelector971.LangIdAsString;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
		 SComboBox97.Enabled := not SComboBox97.Enabled;
		 BmpCombo.Enabled := not BmpCombo.Enabled;
		 SoComboBox97.Enabled := not SoComboBox97.Enabled;
		 SoComboBox971.Enabled := not SoComboBox971.Enabled;
		 FontCombo971.Enabled := not FontCombo971.Enabled;
		 LanguageSelector971.Enabled := not LanguageSelector971.Enabled;
		 DComboBox97.Enabled := not DComboBox97.Enabled;
end;
end.
